#include "stdafx.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "variables.h"
#include "grammar.tab.h"
#include "dva.h"
#include "../shared.h"

extern FILE *yyin;
extern int Error(const char *t, ...);

ForLoop loop[3];

int nFor = -1;
int nIns = 0;

extern int yyparse(void);
extern int calculate_and_save_dependence_vectors(char *filename);

extern int line;
extern int temp0;

struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */
	unsigned int yy_buf_size;
	int yy_n_chars;
	int yy_is_our_buffer;
	int yy_is_interactive;
	int yy_at_bol;
	int yy_fill_buffer;
	int yy_buffer_status;
};


extern struct yy_buffer_state *yy_current_buffer;
extern void yy_flush_buffer(struct yy_buffer_state *b);

int runparser(void)
{
  CString filename;

  filename = path;
  filename += "\\";
  filename += "loop.in";

  yyin = fopen((char *) filename.operator LPCTSTR(),"r");

  if (!yyin)
  {
	  AfxMessageBox("Error reading loop.in (parser)");
	  return -1;
  }

  line = 1;
  int r = yyparse();
 
  if (r == 1)
  {
	RemoveVariables();
	RemoveFours();

	fclose(yyin);

	yy_flush_buffer(yy_current_buffer);
	
	vListRoot = vListPtr = vListLast = NULL;
	vListFourRoot = vListFourPtr = vListFourLast =  NULL;

	temp0 = 0;
	nFor = -1;
	nIns = 0;

	return -1;
  }


  filename = path;
  filename += "\\";
  filename += "loop.out";


  calculate_and_save_dependence_vectors((char *) (LPCSTR) filename);


  RemoveVariables();
  RemoveFours();
  
//  yy_flush_buffer(yy_current_buffer);
  
  vListRoot = vListPtr = vListLast = NULL;
  vListFourRoot = vListFourPtr = vListFourLast =  NULL;

  temp0 = 0;
  nFor = -1;
  nIns = 0;


  fclose(yyin);

  return 0;
}
