#include "stdafx.h"
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include "variables.h"
#include "grammar.tab.h"

/////////////////////////////////////////////////////////////////////////////////////////////////
// Lista zmiennych
variable *vListRoot = NULL;
variable *vListPtr  = NULL;
variable *vListLast = NULL;
variable *vListPrev = NULL;
/////////////////////////////////////////////////////////////////////////////////////////////////
// Lista czworek
four *vListFourRoot = NULL;
four *vListFourPtr  = NULL;
four *vListFourLast = NULL;
four *vListFourPrev = NULL;
/////////////////////////////////////////////////////////////////////////////////////////////////
extern int nFor;
extern int nIns;
extern int endfor;

int temp0 = 0;

extern int Error(const char *t, ...);
//////////////////////////////////////////////////////////////////////////////////////////////////
variable *FindVar(char *vName)
{

   variable *vList;
   int found = 0;


   vList = vListRoot;


   while (vList)
   {
      if (strcmp(vName, vList->name) == 0)
        return vList;


      vList = vList->next;

   }

   return NULL;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
variable *AddVariable(int vType, char *vName, int vValue)
{

   static char num[256];
   static char str[256];
   static int  temp1 = 0;

   variable *v;

   v = FindVar(vName);

   if (v && v->vType != VAR_NUMBER )
   {
          

      if (v->vType != vType)
        Error("Zmienna '%s' ju istnieje", vName);
      else
        return v;

   }

   vListPrev       = vListRoot;
   vListRoot       = (variable *) malloc( sizeof(variable) );
   vListPtr        = vListRoot;

   if (!vListPrev)
     vListLast = vListRoot;

   vListPtr->vType    = vType;
   vListPtr->value    = vValue;
   vListPtr->pfour    = (void *) NULL;
   vListPtr->nFor     = -1;

   vListPtr->next = vListPrev;
   vListPtr->prev = NULL;

   if (vListPrev)
   {
     vListPrev->prev = vListPtr;
   }


   if (strcmp("temp", vName) == 0)
   {
     memset(num, 0, 256);
     memset(str, 0, 256);
     itoa(temp0, num, 10);
     strcat(str, "temp");
     strcat(str, num);
     temp0++;
     vListPtr->name  = (char *) malloc( strlen(str) + 1 );
     strcpy(vListPtr->name, str);
   }
   else
   {
     vListPtr->name  = (char *) malloc( strlen(vName) + 1 );
     strcpy(vListPtr->name, vName);
   }




   return vListPtr;

}
//////////////////////////////////////////////////////////////////////////////////////////////////
int RemoveVariables()
{
   variable *vList;
   variable *vListOld;

   vList = vListRoot;

   while (vList)
   {

      vListOld = vList;
      vList = vList->next;
      if (vListOld->name)
        free(vListOld->name);
      free(vListOld);

   }

   vListRoot = NULL;
   return 0;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
four *AddFour(int instruction, variable *arg0, variable *arg1, variable *output, variable *arg2)
{
   static char str[256];
   static char num[256];
   static int  temp = 0;

   vListFourLast = vListFourPtr;
   vListFourPtr  = (four *) malloc( sizeof(four) );



   vListFourPtr->instruction = instruction;
   vListFourPtr->arg0        = arg0;
   vListFourPtr->arg1        = arg1;
   vListFourPtr->arg2        = arg2;
   vListFourPtr->output      = output;

   vListFourPtr->nFor        = nFor;
   vListFourPtr->nIns        = nIns;



   vListFourPtr->next = NULL;

   if (vListFourLast)
     vListFourPtr->prev = vListFourLast;
   else
     vListFourPtr->prev = NULL;

   if (vListFourRoot == NULL)
   {
     vListFourRoot = vListFourPtr;
   }
   else
   {
     vListFourLast->next = vListFourPtr;
   }


   return vListFourPtr;

}
//////////////////////////////////////////////////////////////////////////////////////////////////
int RemoveFours()
{
   four *vList;
   four *vListOld;

   vList = vListFourRoot;

   while (vList)
   {
      vListOld = vList;
      vList = vList->next;
      free(vListOld);

   }

   vListFourRoot = NULL;

   return 0;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
int ABS(int x)
{ 
  if (x >= 0)
    return x;
  else
    return -x;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
