#define VAR_NUMBER 6
#define VAR_STRING 7


#define READTAB1      666
#define READTAB2      555
#define READTAB3      999
#define WRITETAB1     6661
#define WRITETAB2     5551
#define WRITETAB3     9991

#define READ_TABLE 0
#define WRITE_TABLE 1
#define CALCULATING 2


#define SINGLE_TABLE 4
#define DOUBLE_TABLE 8
#define TRIPLE_TABLE 9
#define VAR_SIMPLE    10
#define VAR_TEMP      12

#define SUB 45
#define MUL 46
#define NEG 47
#define ADD 48


extern int vID;
extern int vIDRec;

/* Struktura zawierajaca zmienne */
typedef struct variable {

   char *name;          // nazwa zmiennej lub funkcji
   int value;           // wartosc, jezeli kind = VAR_NUMBER
   int vType;
   int temp;            // wykorzystywana w trakcie obliczania ideksw

   void *pfour;

   struct variable *next;
   struct variable *prev;

   int nFor;          


} variable;


/* Struktura zawierajaca czworki */
typedef struct four {

  int instruction;          // numer instruckcji lub FUNCTION albo LABEL
  variable *arg0;                 // jesli FUNCTION, to zawiera id funckcji
  variable *arg1;
  variable *arg2;
  variable *output;

  int operation;

  int nFor;   // numer ptli w ktrej wykonuje si dana czwrka
  int nIns;   // numer instrukcji w danej ptli;


  struct four *start; // wskanik na czwrk zaczynajc obliczenia

  struct four *next;
  struct four *prev;

} four;

/////////////////////////////////////////////////////////////////////////////////////////////////
extern variable *vListRoot;
extern variable *vListPtr;
extern variable *vListLast;
/////////////////////////////////////////////////////////////////////////////////////////////////
extern four *vListFourRoot;
extern four *vListFourLast;
extern four *vListFourPtr;
/////////////////////////////////////////////////////////////////////////////////////////////////
extern variable *FindVar(char *vName);
extern variable *AddVariable(int vType, char *vName, int vValue);
extern int RemoveVariables();

extern int temp0;

int AddParameter(variable *v);
int RemoveParameters();


four *AddFour(int instruction, variable *arg0, variable *arg1, variable *output, variable *arg2);
int RemoveFours();
extern int ABS(int x);
