#include "stdafx.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include "variables.h"
#include "grammar.tab.h"
#include "dva.h"
#include "vectors.h"

extern struct ForLoop loop[];

#define MAXDEP 100  // maksymalna liczba zalenoci
#define MAXVAR 30   // masksymalna liczba wektorw

Dependences dep[MAXDEP];

WriteReadDep write[MAXVAR][MAXDEP];
WriteReadDep read[MAXVAR][MAXDEP];
int          maxr[MAXVAR];
int          maxw[MAXVAR];
variable     *tabvar[MAXVAR];
int          tv = 0; // liczba elementw w tabvar

extern       int nFor;
extern       int nIns;


FILE *file;

///////////////////////////////////////////////////////////////////////////////
int check_condition(int a, int nFor)
{

   int condition;
   int b;


   condition = loop[nFor].condition;
   b         = loop[nFor].bound;

   switch (condition)
   {

      case LESS:
                  if (a < b)
                    return 1;
                  else
                    return 0;

                  break;

      case GREATER:

                  if (a > b)
                    return 1;
                  else
                    return 0;

                  break;

      case LESS_OR_EQUAL:

                  if (a <= b)
                    return 1;
                  else
                    return 0;

                  break;

      case GREATER_OR_EQUAL:

                  if (a >= b)
                    return 1;
                  else
                    return 0;

                  break;
       
                  
   }

}
///////////////////////////////////////////////////////////////////////////////
void display_table_type(four *f)
{
  switch (f->instruction)
  {
     case READTAB1:  printf("%s[%s]",         f->arg0->name,f->arg1->name); break;
     case READTAB2:  printf("%s[%s][%s]",     f->arg0->name,f->arg1->name,f->output->name); break;
     case READTAB3:  printf("%s[%s][%s][%s]", f->arg0->name,f->arg1->name,f->output->name,f->arg2->name); break;
     case WRITETAB1: printf("%s[%s]",         f->arg0->name,f->arg1->name); break;
     case WRITETAB2: printf("%s[%s][%s]",     f->arg0->name,f->arg1->name,f->output->name); break;
     case WRITETAB3: printf("%s[%s][%s][%s]", f->arg0->name,f->arg1->name,f->output->name,f->arg2->name); break;
  }
}
///////////////////////////////////////////////////////////////////////////////
int display_dependences()
{


   int n = 0;
   int i;
   int k;

   fill_tabvar();

   for (n = 0; n < tv; n++)
   {

      k = find_dependences_for_one_var(n, tabvar[n]);

      for (i = 0; i < k; i++)
      {
         if (dep[i].type == READ_WRITE)
         {
           printf("READ_WRITE : ");
           display_table_type(dep[i].f0);
           printf("->");
           display_table_type(dep[i].f1);
           printf("\n");

         }
         if (dep[i].type == WRITE_READ)
         {
           printf("WRITE_READ : ");
           display_table_type(dep[i].f0);
           printf("->");
           display_table_type(dep[i].f1);
           printf("\n");

         }
         if (dep[i].type == WRITE_WRITE)
         {
           printf("WRITE_WRITE : ");
           display_table_type(dep[i].f0);
           printf("->");
           display_table_type(dep[i].f1);
           printf("\n");

         }

      }   
   }
   return 0;

}
///////////////////////////////////////////////////////////////////////////////
int find_start_fours()
{
   four *f;
   four *ft;


   f = ft = vListFourRoot;


   while (f)
   {
      if (f->operation == WRITE_TABLE || 
          f->operation == READ_TABLE)
      {

          ft = f->prev;

          if (ft == NULL)
            f->start = f;

          else
          {

             while (ft && 
                    ft->operation != WRITE_TABLE &&
                    ft->operation != READ_TABLE)
             {
                ft = ft->prev;
             }

             if (ft)
               f->start = ft->next;
             else
               f->start = vListFourRoot;
          }
      }

      f = f->next;
   }
   return 0;

}
///////////////////////////////////////////////////////////////////////////////
int fill_tabvar()
{
   variable *v = vListRoot;
   int i = 0;

   while (v)
   {


     if (v->vType == SINGLE_TABLE ||
         v->vType == DOUBLE_TABLE ||
         v->vType == TRIPLE_TABLE)
     {
       tabvar[i] = v;
       i++;
     }

     v = v->next;
   }

   tv = i;

   return 0;
}
///////////////////////////////////////////////////////////////////////////////
int find_dependences_for_one_var(int n, variable *v)
{

   int i = 0;
   int j = 0;
   int k = 0;

   four *f = vListFourRoot;

   while (f)
   {
       if (f->operation == WRITE_TABLE && f->arg0 == v)
       {
         write[n][i].f = f;
         write[n][i].nIns = f->nIns;

         i++;
       }

       if (f->operation == READ_TABLE && f->arg0 == v)
       {
         read[n][j].f = f;
         read[n][j].nIns = f->nIns;

         j++;
       }

       f = f->next;


   }
   maxr[n] = j;
   maxw[n] = i;


   // Find READ_WRITE  - FLOW

   for (i = 0; i < maxr[n]; i++)
     for (j = 0; j < maxw[n]; j++)
     {

        if (read[n][i].nIns == write[n][j].nIns)
        {
           dep[k].f0 = read[n][i].f;
           dep[k].f1 = write[n][j].f;

           dep[k].nIns1 = write[n][j].nIns;
           dep[k].nIns0 = read[n][i].nIns;

           dep[k].type = READ_WRITE;

           k++;
        }

     }


   // Find WRITE_READ  - ANTI

   for (i = 0; i < maxw[n]; i++)
     for (j = 0; j < maxr[n]; j++)
     {

        if ((read[n][j].nIns - write[n][i].nIns >= 1) ||
            (write[n][i].nIns - read[n][j].nIns >= 1))
        {
           dep[k].f0 = write[n][i].f;
           dep[k].f1 = read[n][j].f;

           dep[k].nIns0 = write[n][i].nIns;
           dep[k].nIns1 = read[n][j].nIns;


           dep[k].type = WRITE_READ;

           k++;
        }

     }

   // Find WRITE_WRITE - OUTPUT

   for (i = 0; i < maxw[n]; i++)
     for (j = 0; j < maxw[n]; j++)
     {

        if (write[n][i].nIns - write[n][j].nIns == 1)
        {
           dep[k].f0 = write[n][i].f;
           dep[k].f1 = write[n][j].f;

           dep[k].nIns0 = write[n][i].nIns;
           dep[k].nIns1 = write[n][j].nIns;


           dep[k].type = WRITE_WRITE;

           k++;
        }

     }


  return k;
   
}
///////////////////////////////////////////////////////////////////////////////
int get_index(variable *v, int i, int j, int k)
{

  if (v->vType == VAR_NUMBER)
    return v->value;
  else
  if (v->vType == VAR_SIMPLE)
  switch (v->nFor)
  {
    case 0:
             return i;
             break;
    case 1:
             return j;
             break;
    case 2:
             return k;
             break;
  }
  else
  if (v->vType == VAR_TEMP)
    return v->temp;

  return 0;
}
///////////////////////////////////////////////////////////////////////////////
Index calculate_indexes(four *d, int i, int j, int k)
{

   four *f = d->start;

   variable *v0, *v1, *v2;
   Index ind;

   v0 = d->arg1;
   v1 = d->output;
   v2 = d->arg2;
  
   while (f != d) 
   {
     switch (f->instruction)
     {
       case ADD:
                 f->output->temp = get_index(f->arg0, i, j, k) + 
                                   get_index(f->arg1, i, j, k);
                 
                 break;
       case SUB:
                 f->output->temp = get_index(f->arg0, i, j, k) -
                                   get_index(f->arg1, i, j, k);
                 break;
       case MUL:
                 f->output->temp = get_index(f->arg0, i, j, k) * 
                                   get_index(f->arg1, i, j, k);
                 break;  
       case NEG:
                 f->output->temp = -get_index(f->arg0, i, j, k);
                 break;  
     }


     f = f->next;

   } 

//   ind.i = get
   switch (d->arg0->vType)
   {
     case SINGLE_TABLE:
                         ind.i = get_index(v0, i, j, k);

                         break;
     case DOUBLE_TABLE:
                         ind.i = get_index(v0, i, j, k);
                         ind.j = get_index(v1, i, j, k);

                         break;
                           
     case TRIPLE_TABLE:
                         ind.i = get_index(v0, i, j, k);
                         ind.j = get_index(v1, i, j, k);
                         ind.k = get_index(v2, i, j, k);

                         break;
                           
   }
   ind.n0 = i;
   ind.n1 = j;
   ind.n2 = k;

   return ind;

} 
///////////////////////////////////////////////////////////////////////////////
int WriteF(const char *t, ...)
{
   char buf[256];

   va_list ap;
   va_start(ap,t);
   vsprintf(buf,t,ap);
   va_end(ap);

   fwrite(buf, strlen(buf), 1, file);

   return strlen(buf);
}
///////////////////////////////////////////////////////////////////////////////
int SaveDependences(int p, Index *i0, Index *i1, int m, int dt)
{
   int i, j, l;

   int found = 0;

   long int pos0;
   long int pos1;


   int c = 0;


   switch (dt)
   {
     case READ_WRITE:  WriteF("DEPTYPE : READ_WRITE "); break;
     case WRITE_READ:  WriteF("DEPTYPE : WRITE_READ "); break;
     case WRITE_WRITE: WriteF("DEPTYPE : WRITE_WRITE ");                   
   }
   pos0 = ftell(file);
   WriteF("     \n");

   for (i = 0; i < p; i++)
   {

     for (j = 0; j < p; j++)
     {
      
        switch (nFor)
        {
          case 0:
          
                    if (i0[i].i == i1[j].i)
                    {
                      WriteF("%d,%d,0->%d,%d,0\n", i0[i].n0, dep[m].nIns0,
                                                   i1[j].n0, dep[m].nIns1);
                      found = 1;

                    }

                    break;

          case 1:

                    if (i0[i].i == i1[j].i &&
                        i0[i].j == i1[j].j)
                    {

                      WriteF("%d,%d,%d->%d,%d,%d\n", i0[i].n0, i0[i].n1, dep[m].nIns0, 
                                                     i1[j].n0, i1[j].n1, dep[m].nIns1);
                      found = 1;

                     
                    }
                    break;
          case 2:



                    if (i0[i].i == i1[j].i &&
                        i0[i].j == i1[j].j &&
                        i0[i].k == i1[j].k)
                    {

                      WriteF("%d,%d,%d->%d,%d,%d\n", i0[i].n0, i0[i].n1, i0[i].n2,
                                                     i1[j].n0, i1[j].n1, i1[j].n2);
                      found = 1;
                       
                    }

                   break; 


        }

        if (found)
        {
          found = 0;
          c++;
                        
          //break;
        }

     }
   }  
   
   pos1 = ftell(file);
   fseek(file, pos0, SEEK_SET);
   l = WriteF("%d", c);
   for (i = 0; i < 7 - l - 2; i++)
     WriteF(" ");
   WriteF("\n");
   fseek(file, pos1, SEEK_SET);

   return 0;
}
///////////////////////////////////////////////////////////////////////////////
int calculate_and_save_dependence_vectors(char *filename)
{

   int i, j, k, n, m, p, deps;

   int size;

   Index *pInd0;
   Index *pInd1;

   file = fopen(filename, "wr");

   if (!file)
   {
     printf("Error: Can't open %s to write\n", filename);
     return -1;
   }
   WriteF("Dimension : %d, %d\n\n", 3, nFor + 1);

   for (i = 0; i < nFor + 1; i++)
   {
     WriteF("Loop %d\n\n", i +1);
     WriteF("start = %d\n", loop[i].start);
     WriteF("bound = %d\n", loop[i].bound);
     WriteF("step = %d\n\n", loop[i].step);
   }

   if (nFor == 0)
   {
        WriteF("Loop %d\n\n", i + 1);
        WriteF("start = %d\n", 0);
        WriteF("bound = %d\n", nIns - 1);
        WriteF("step = %d\n\n", 1);

        WriteF("Loop %d\n\n", i + 2);
        WriteF("start = %d\n", 0);
        WriteF("bound = %d\n", 0);
        WriteF("step = %d\n\n", 0);
   }

   if (nFor == 1)
   {
        WriteF("Loop %d\n\n", i + 1);
        WriteF("start = %d\n", 0);
        WriteF("bound = %d\n", nIns - 1);
        WriteF("step = %d\n\n", 1);
   }
   
   fill_tabvar();
   find_start_fours();

   for (n = 0; n < tv; n++)
   {

      deps = find_dependences_for_one_var(n, tabvar[n]);  // dla kolejnych zmiennych wyszukaj zalenoci

      if (dep !=0 )
      {

          WriteF("\nVariable : %s\n", tabvar[n]->name);
          WriteF("Dependences : %d\n\n", deps);


          for (m = 0; m < deps; m++)  // dla kadej z tych zalenoci
          {
             p = 0;

             size = loop[0].range + 1;

             if (loop[1].range > 0)
               size *= loop[1].range + 1;

             if (loop[2].range > 0)
               size *= loop[2].range + 1;

             size *= sizeof(Index);

             pInd0 = (Index *) malloc(size);
             pInd1 = (Index *) malloc(size);

             switch (nFor)        // w zalenoci od liczby ptli
             {         

                case 0:


                         i = loop[0].start;

                         while (check_condition(i, 0)) 
                         {

                           pInd0[p] = calculate_indexes(dep[m].f0, i, 0, 0);
                           pInd1[p] = calculate_indexes(dep[m].f1, i, 0, 0);

                          // printf("%d\n", i);

                           p++;

                           i += loop[0].step;

                         }


                         break;

                case 1:

                         i = loop[0].start;


                         while (check_condition(i, 0)) 
                         {

                            j = loop[1].start;

                            while (check_condition(j, 1)) 
                            {
                              pInd0[p] = calculate_indexes(dep[m].f0, i, j, 0);
                              pInd1[p] = calculate_indexes(dep[m].f1, i, j, 0);

                              p++;


                              j += loop[1].step;

                            };

                            i += loop[0].step;

                         };
                         break;
                case 2:

                         i = loop[0].start;

                         while (check_condition(i, 0)) 
                         {
                          
                            j = loop[1].start;


                            while (check_condition(j, 1)) 
                            {

                               k = loop[2].start;

                               while (check_condition(k, 2)) 
                               {

                                 pInd0[p] = calculate_indexes(dep[m].f0, i, j, k);
                                 pInd1[p] = calculate_indexes(dep[m].f1, i, j, k);

                            //     printf("%d,%d,%d\n",pInd0[p].i,pInd0[p].j,pInd0[p].k);
       
                                 p++;

                                 k += loop[2].step;

                               };

                               j += loop[1].step;

                            };
                            
                            i += loop[0].step;

                         };

                         break;

             }

             SaveDependences(p, pInd0, pInd1, m, dep[m].type);

  		     free(pInd0);
             free(pInd1);

          }
          WriteF("END\n");
      }
   }
   fclose(file);

   return 0;
}
///////////////////////////////////////////////////////////////////////////////
