%{                                                      	
  #include "./variables.h"    
  #include "./paraller.h"
  #include <string.h>
  #include <stdio.h>
  #include <stdarg.h>
  

  extern int line;
  extern int nFor;
  extern int nIns; // numer instukcji
  extern struct ForLoop loop[];
  

  char str0[256];
  char str1[256];

  int endfor;

  four *ftemp;

  void Error(const char *t, ...)
  {
    char buf[256];

    va_list ap;
    va_start(ap,t);
    vsprintf(buf,t,ap);
    va_end(ap);
    CString str.Format("Blad (linia %d): %s.\n", line, buf);
    AfxMessageBox(str);
//    printf("Blad (linia %d): %s.\n", line, buf);
    RemoveVariables();
//    RemoveFours();
//    exit(-1);
  }  

  int var2flag = 0;
%}

%union {

  int ival;
  int op;
  char name[256];
  struct variable *v;
}
%type <v> IDNUM IDTAB IDTAB2 IDS2 var cmp
%type <op> cmp_oper
%type <ival> increment_operator

%token <name> ID 
%token <ival> NUMBER
%token FOR
%token LESS
%token GREATER
%token LESS_OR_EQUAL
%token GREATER_OR_EQUAL

%right '='
%left '-' '+' 
%left '*'
%left _NEG_


%%

////////////////////////////////////////////////////////////////////////////////

code: | c
;

c: instruction |
   c instruction
;


code_block: '{' code '}'
;


////////////////////////////////////////////////////////////////////////////////
increment_operator: ID '+' '+' { $$=1; }
                    |            
                    ID '-' '-' { $$ = -1; }
                    |
                    ID '+' '=' NUMBER { $$ = $4; }
                    |
                    ID '-' '=' NUMBER { $$ = -$4; }
                    |
                    '-' '-' ID { $$ = -1; }
                    |
                    '+' '+' ID { $$ = 1; }
; 
IDS2: ID
      {
        $$ = AddVariable(VAR_SIMPLE, $1,-1);
      }
      |
      IDTAB2
      {
        $$ = $1;
      }

IDNUM: ID
       {

        $$ = AddVariable(VAR_SIMPLE, $1,-1);

        if ($$->nFor == -1)
           Error("Niezadeklarowany indeks '%s'", $1);


         
       }
       | 
       NUMBER 
       {         
         $$ = AddVariable(VAR_NUMBER, "number", $1);

       }
;

IDTAB: ID '[' var ']'
       {      
          if (nFor != 0)
            Error("Niewaciwy rozmiar tablicy");

          $$ = AddVariable(SINGLE_TABLE, $1, -1);
          $$->pfour = (void *) AddFour(READTAB1, $$, $3, NULL, NULL);
          ((four *) $$->pfour)->operation = READ_TABLE;
       }
       | 
       ID '[' var ']' '[' var ']'
       {
          if (nFor != 1)
            Error("Niewaciwy rozmiar tablicy");

          $$ = AddVariable(DOUBLE_TABLE, $1, -1);
          $$->pfour = (void *) AddFour(READTAB2, $$, $3, $6, NULL);
          ((four *) $$->pfour)->operation = READ_TABLE;
       }
       |
       ID '[' var ']' '[' var ']' '[' var ']' 
       {
          if (nFor != 2)
            Error("Niewaciwy rozmiar tablicy");

          $$ = AddVariable(TRIPLE_TABLE, $1, -1);
          $$->pfour = (void *) AddFour(READTAB3, $$, $3, $6, $9);
          ((four *) $$->pfour)->operation = READ_TABLE;
       }
;

IDTAB2: ID '[' var ']'
        {
          if (nFor != 0)
            Error("Niewaciwy rozmiar tablicy");
        
          $$ = AddVariable(SINGLE_TABLE, $1, -1);
          $$->pfour = (void *) AddFour(WRITETAB1, $$, $3, NULL, NULL);
          ((four *) $$->pfour)->operation = WRITE_TABLE;
         
        }
        | 
        ID '[' var ']' '[' var ']'
        {
          if (nFor != 1)
            Error("Niewaciwy rozmiar tablicy");
          $$ = AddVariable(DOUBLE_TABLE, $1, -1);
          $$->pfour = (void *) AddFour(WRITETAB2, $$, $3, $6, NULL);
          ((four *) $$->pfour)->operation = WRITE_TABLE;
        }
        | 
        ID '[' var ']' '[' var ']' '[' var ']'
        {
          if (nFor != 2)
            Error("Niewaciwy rozmiar tablicy");
          $$ = AddVariable(TRIPLE_TABLE, $1, -1);
          $$->pfour = (void *) AddFour(WRITETAB3, $$, $3, $6, $9);
          ((four *) $$->pfour)->operation = WRITE_TABLE;
        } 
;

////////////////////////////////////////////////////////////////////////////////

instruction: instr_for |
             instr_operation ';'
             {
               nIns++;
             }
;

instr_or_code_block: instruction |
                     code_block
;
////////////////////////////////////////////////////////////////////////////////

cmp_oper: LESS              { $$ = LESS             } |
          GREATER           { $$ = GREATER          } |
          LESS_OR_EQUAL     { $$ = LESS_OR_EQUAL    } |
          GREATER_OR_EQUAL  { $$ = GREATER_OR_EQUAL }
;

cmp: ID cmp_oper NUMBER
     {
 
        loop[nFor].bound = $3;
        loop[nFor].condition = $2;

        loop[nFor].range = ABS(loop[nFor].start) + ABS(loop[nFor].bound);

     }
;

////////////////////////////////////////////////////////////////////////////////

instr_for: FOR
           { 
             nFor++;
             if (nFor > 3)
               Error("Za duzo petli FOR (max 3)");
           }
           '('
           ID '=' NUMBER ';'
           {
              loop[nFor].start = $6;
              AddVariable(VAR_SIMPLE, $4, -1)->nFor = nFor;

           }
           cmp ';'
           {
           }
           increment_operator
           {
              loop[nFor].step = $12;
           }
           ')'
           instr_or_code_block
;

////////////////////////////////////////////////////////////////////////////////
instr_operation: IDS2 '=' var2 {}
;

var: 
     var '-' var
     {
        $$ = AddVariable(VAR_TEMP, "temp", -1);

        (AddFour(SUB, $1, $3, $$, NULL))->operation = CALCULATING;
        

     }
     |
     var '+' var
     {
        $$ = AddVariable(VAR_TEMP, "temp", -1);

        (AddFour(ADD, $1, $3, $$, NULL))->operation = CALCULATING;

     } 
     |
     var '*' var
     {
        $$ = AddVariable(VAR_TEMP, "temp", -1);

        (AddFour(MUL, $1, $3, $$, NULL))->operation = CALCULATING;
     }
     |
     '-' var %prec _NEG_
     {           
        $$ = AddVariable(VAR_TEMP, "temp", -1);


        (AddFour(NEG, $2, NULL, $$, NULL))->operation = CALCULATING;


     }
     |
     IDNUM
     {
       $$ = $1;
     }
;

var2: 
     var2 '-' var2 {} |
     var2 '+' var2 {} |
     var2 '*' var2 {} |
     '-' var2 %prec _NEG_ {}|
     IDNUM {} |
     IDTAB {}
;

//////////////////////////////////////////////////////////////////////////////
    

%%

yyerror(char *s)
{
  CString str;
  str.Format("Blad (linia %d) : Niepoprawna skladnia.\n", line);
  AfxMessageBox(str);
//  printf("Blad (linia %d) : Niepoprawna skladnia.\n", line);
//  exit(-1);
}

