// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "paraller.h"
#include "dane.h"
#include "shared.h"
#include "parallerDoc.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_EDIT_DATA, OnEditData)
	ON_UPDATE_COMMAND_UI(ID_VIEW_AXIS, OnUpdateViewAxis)
	ON_COMMAND(ID_VIEW_AXIS, OnViewAxis)
	ON_COMMAND(ID_VIEW_POSITIONS, OnViewPositions)
	ON_UPDATE_COMMAND_UI(ID_VIEW_POSITIONS, OnUpdateViewPositions)
	ON_COMMAND(ID_VIEW_REALDIMENSION, OnViewRealdimension)
	ON_UPDATE_COMMAND_UI(ID_VIEW_REALDIMENSION, OnUpdateViewRealdimension)
	ON_COMMAND(ID_VIEW_ST, OnViewSt)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ST, OnUpdateViewSt)
	ON_COMMAND(ID_VIEW_ARC, OnViewArc)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ARC, OnUpdateViewArc)
	ON_COMMAND(ID_BUTTON_BKG, OnButtonBkg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	ViewAxis = 1;
	ShowRealDimension = 0;
	ShowPositions = 1;
	ShowRealPositions = 0;
	ShowArcs = 1;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_LEFT
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

extern CString LoopStr;

void CMainFrame::OnEditData() 
{
	DataChange = 0;

	Dane dane;
	dane.DoModal();

	Invalidate(FALSE);


}


void CMainFrame::OnUpdateViewAxis(CCmdUI* pCmdUI) 
{

	if (ViewAxis)
	  pCmdUI->SetCheck(1);
	else
	  pCmdUI->SetCheck(0);

}

void CMainFrame::OnViewAxis() 
{
	ViewAxis = 1 - ViewAxis;
	Invalidate(FALSE);

}

void CMainFrame::OnViewPositions() 
{
	// TODO: Add your command handler code here
	ShowPositions = 1 - ShowPositions;
	Invalidate(FALSE);
	
}

void CMainFrame::OnUpdateViewPositions(CCmdUI* pCmdUI) 
{
	if (ShowPositions)
	  pCmdUI->SetCheck(1);
	else
	  pCmdUI->SetCheck(0);
	
}

void CMainFrame::OnViewRealdimension() 
{
	ShowRealDimension = 1 - ShowRealDimension;
	if (ShowRealDimension && !ShowRealPositions)
		ShowRealPositions = 1;
	else
		ShowRealPositions = 0;
	Invalidate(FALSE);
	
}

void CMainFrame::OnUpdateViewRealdimension(CCmdUI* pCmdUI) 
{
	if (ShowRealDimension)
	  pCmdUI->SetCheck(1);
	else
	  pCmdUI->SetCheck(0);
	
}

void CMainFrame::OnViewSt() 
{
	ShowRealPositions = 1 - ShowRealPositions;
	Invalidate(FALSE);

}

void CMainFrame::OnUpdateViewSt(CCmdUI* pCmdUI) 
{
	if (ShowRealPositions)
	  pCmdUI->SetCheck(1);
	else
	  pCmdUI->SetCheck(0);
	
}

void CMainFrame::OnViewArc() 
{
	ShowArcs = 1 - ShowArcs;
	Invalidate(FALSE);
	
}

void CMainFrame::OnUpdateViewArc(CCmdUI* pCmdUI) 
{
	if (ShowArcs)
	  pCmdUI->SetCheck(1);
	else
	  pCmdUI->SetCheck(0);
	
}


void CMainFrame::OnButtonBkg() 
{
	CColorDialog dlg;
	dlg.DoModal();
	COLORREF color = dlg.GetColor();

	int r = ((color >> 0)  & 0x000000ff);
	int g = ((color >> 8)  & 0x000000ff);
	int b = ((color >> 16) & 0x000000ff);


	float fr = (float) r / 256.0;
	float fg = (float) g / 256.0;
	float fb = (float) b / 256.0;
	
	glClearColor(fr, fg, fb, 0);

	Invalidate();

	
}
