// parallerDoc.cpp : implementation of the CParallerDoc class
//


#include "stdafx.h"
#include "paraller.h"

#include "parallerDoc.h"
#include "console.h"
#include "shared.h"
#include <iostream>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParallerDoc

IMPLEMENT_DYNCREATE(CParallerDoc, CDocument)

BEGIN_MESSAGE_MAP(CParallerDoc, CDocument)
	//{{AFX_MSG_MAP(CParallerDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParallerDoc construction/destruction

CParallerDoc::CParallerDoc()
{
    //con.RedirectToConsole(0);      
    //cout << "Console opened\n";

	pVarRoot = pVarTemp = pVarLast = NULL;
	
//	DataLoaded = 0;

	loop[0].start = -1; loop[0].bound = 1;
	loop[1].start = -1; loop[1].bound = 1;
	loop[2].start = -1; loop[2].bound = 1;

	FindMinMax();
	//LoadData("loop.out");

}

CParallerDoc::~CParallerDoc()
{
	RemoveVariables();

//	CConsole con;
//	con.RedirectToConsole(0);
}

BOOL CParallerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CParallerDoc serialization

void CParallerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}


/////////////////////////////////////////////////////////////////////////////
// CParallerDoc diagnostics

#ifdef _DEBUG
void CParallerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CParallerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CParallerDoc commands

/////////////////////////////////////////////////////////////////////////////
void CParallerDoc::FindChar(int s) //Szuka jednego znaku
{
  int ch;
  ch = 0;
  while (ch != s) 
	  ch = getc(file); 
  
  ch = getc(file);
}
/////////////////////////////////////////////////////////////////////////////
int CParallerDoc::FindString(char *str) //Szuka ciagu znakow
{
  int i;
  int ch;
  int dl;

  i  = 0;
  ch = 0;
  dl = strlen(str);
  while ( (i < dl) && (ch != EOF) )
  {
    ch = getc(file);
    if (ch == *(str + i)) 
	  i++; 
	else 
	  i = 0;

  }
  if (ch == EOF)
	return -1;
  else 
	return 0;


}
/////////////////////////////////////////////////////////////////////////////
void CParallerDoc::RemoveVariables()
{
	Variable *v = pVarRoot;

	while (v)
	{
		Dependence *d = v->pDepRoot;

		while (d)
		{
			Dependence *dtemp;
			dtemp = d->next;

			delete d;

			d = dtemp;

		}

		Variable *vtemp;
		vtemp = v->next;
		delete [] v->name;
		delete v;
		v = vtemp;
		
	}

	pVarRoot = pVarTemp = pVarLast = NULL;

}
/////////////////////////////////////////////////////////////////////////////
Dependence* CParallerDoc::add_dep(Index ind0, Index ind1)
{
   pVarTemp->pDepLast = pVarTemp->pDepTemp;
   pVarTemp->pDepTemp = new Dependence;



   pVarTemp->pDepTemp->ind0 = ind0;
   pVarTemp->pDepTemp->ind1 = ind1;

   pVarTemp->pDepTemp->next = NULL;


   if (pVarTemp->pDepRoot == NULL)
   {
     pVarTemp->pDepRoot = pVarTemp->pDepTemp;
   }
   else
   {
     pVarTemp->pDepLast->next = pVarTemp->pDepTemp;
   }

   return pVarTemp->pDepTemp;

}
/////////////////////////////////////////////////////////////////////////////
Variable* CParallerDoc::add_var(char *name)
{
   pVarLast = pVarTemp;
   pVarTemp = new Variable;


   pVarTemp->name = new char[strlen(name) + 1];
   strcpy(pVarTemp->name, name);


   pVarTemp->pDepLast = NULL;
   pVarTemp->pDepRoot = NULL;
   pVarTemp->pDepTemp = NULL;

   pVarTemp->next = NULL;


   if (pVarRoot == NULL)
   {
     pVarRoot = pVarTemp;
   }
   else
   {
     pVarLast->next = pVarTemp;
   }


   return pVarTemp;

}
/////////////////////////////////////////////////////////////////////////////
int CParallerDoc::LoadData(char *filename)
{

	file = fopen(filename, "r");

	if (!file)
	{
		AfxMessageBox("Error reading loop.out (LoadData)");
		return -1;
	}


	Index ind0;
	Index ind1;

	int temp;
	int type;
	int quit = 0;

	unsigned char c0,c1,c2;
	char name[256];
	
	if (FindString("Dimension :") < 0)
	{
		AfxMessageBox("Error reading loop.out (Bad Format, LoadData)");
		return -1;

	};
	fscanf(file,"%d", &dimension);
	FindString(",");
	fscanf(file,"%d", &realdimension);

	//cout << "Dimension : " << dimension << endl << endl;
	//cout << "Real dimension : " << realdimension << endl << endl;

	for (int i = 0; i < dimension; i++)
	{
		FindString("start =");
		fscanf(file, "%d", &loop[i].start);
		FindString("bound =");
		fscanf(file, "%d", &loop[i].bound);
		FindString("step =");
		fscanf(file, "%d", &loop[i].step);


		//cout << "Loop " << i + 1 << endl << endl;
		//cout << "start = " << loop[i].start << endl;
		//cout << "bound = " << loop[i].bound << endl;
		//cout << "step  = " << loop[i].step << endl;
	}

	while (FindString("Variable :") != -1)
	{
		
		fscanf(file, "%s", name);
		add_var(name);
		//cout << "Variable :" << name << endl;
		FindString("Dependences :");		            
		fscanf(file, "%d", &temp);
		//cout << "Dependences :" << temp << endl;

		quit = 0;

		while (!quit)
		{
			FindString("DEPTYPE :");
			fscanf(file, "%s", name);

			if (strcmp(name, "READ_WRITE") == 0)
				type = READ_WRITE;
			else
				if (strcmp(name, "WRITE_READ") == 0)
				type = WRITE_READ;
			else
				type = WRITE_WRITE;

			fscanf(file, "%d", &temp);

			//cout << name << " " << temp << endl;



			for (i = 0; i < temp; i++)
			{
				  fscanf(file, "%d", &ind0.i);
				  FindString(",");
				  fscanf(file, "%d", &ind0.j);
				  FindString(",");
				  fscanf(file, "%d", &ind0.k);

				  FindString("->");

				  fscanf(file, "%d", &ind1.i);
				  FindString(",");
				  fscanf(file, "%d", &ind1.j);
				  FindString(",");
				  fscanf(file, "%d", &ind1.k);

				  //cout << ind0.i << ',' << ind0.j << ',' << ind0.k << "->" 
				  //     << ind1.i << ',' << ind1.j << ',' << ind1.k << endl;

				  ind0.dep = type;
				  ind1.dep = type;

				  add_dep(ind0, ind1);

				  
			}
		

			fscanf(file, "\n%c%c%c", &c0, &c1, &c2);


			if (c0 == 'E' &&
				c1 == 'N' &&
				c2 == 'D')
  			  quit = 1;
			else
			  fseek(file, -3, SEEK_CUR);

		}

	}            

	fclose(file);

	//cout << "END READING" << endl;

	// calculate in,out,between

	FindIOBVectors();


	return 0;
}
/////////////////////////////////////////////////////////////////////////////
int CParallerDoc::Compare(Index *ind0, Index *ind1)
{
	switch (realdimension)
	{
	case 3:
		     if (ind0->k != ind1->k)
				 return 0;
	case 2:
			 if (ind0->j != ind1->j)
				 return 0;
	case 1:
		     if (ind0->i != ind1->i)
				 return 0;
	}
	
	return 1;

}

/////////////////////////////////////////////////////////////////////////////
bool CParallerDoc::CompareI(Index *ind0, Index *ind1)
{
	// true - mniejszy
	// false - wiekszy

	if (ind0->i < ind1->i)
		return true;
	else
	if (ind0->i > ind1->i)
		return false;

	if (ind0->j < ind1->j)
		return true;
	else
	if (ind0->j > ind1->j)
		return false;


	if (ind0->k < ind1->k)
		return true;
	else
	if (ind0->k > ind1->k)
		return false;

	return false;
}

bool CParallerDoc::FindMinMax()
{

	mini =  1000000000;
	minj =  1000000000;
	mink =  1000000000;
	maxi = -1000000000;
	maxj = -1000000000;
	maxk = -1000000000;

	bool bAreDeps = false;

	Variable *v = pVarRoot;

	while (v)
	{
		Dependence *d = v->pDepRoot;

		while (d)
		{
			bAreDeps = true;

			if (d->ind0.i < mini) mini = d->ind0.i;
			if (d->ind0.j < minj) minj = d->ind0.j;
			if (d->ind0.k < mink) mink = d->ind0.k;

			if (d->ind0.i > maxi) maxi = d->ind0.i;
			if (d->ind0.j > maxj) maxj = d->ind0.j;
			if (d->ind0.k > maxk) maxk = d->ind0.k;
	
			if (d->ind1.i < mini) mini = d->ind1.i;
			if (d->ind1.j < minj) minj = d->ind1.j;
			if (d->ind1.k < mink) mink = d->ind1.k;

			if (d->ind1.i > maxi) maxi = d->ind1.i;
			if (d->ind1.j > maxj) maxj = d->ind1.j;
			if (d->ind1.k > maxk) maxk = d->ind1.k;
		
			d = d->next;


		}

		v = v->next;
		
	}
	if (!bAreDeps)
	{
		mini = -1;
		maxi = 1;
		minj = -1;
		maxj = 1;
		mink = -1;
		maxk = 1;
	}


	//cout << "Min " << mini << "," << minj << "," << mink << endl;
	//cout << "Max " << maxi << "," << maxj << "," << maxk << endl;

	return bAreDeps;

}
void CParallerDoc::FindIOBVectors()
{
	int i, j, k;

	in = out = between = 0;

	if (!FindMinMax())
		return;



	int ni = maxi - mini;
	int nj = maxj - minj;
	int nk = maxk - mink;

	int nSize = (ni + 1) * (nj + 1) * (nk + 1);


	Index * indTab = new Index[nSize];

	for (i = 0; i < nSize; i++)
	{
		indTab[i].in = false;
		indTab[i].out = false;
	}

	

	Variable *v = pVarRoot;

	while (v)
	{
		Dependence *d = v->pDepRoot;

		while (d)
		{

			i = d->ind0.i - mini;
			j = d->ind0.j - minj;
			k = d->ind0.k - mink;


			indTab[i + j * ni + k * (nj * ni)].out = true;

			i = d->ind1.i - mini;
			j = d->ind1.j - minj;
			k = d->ind1.k - mink;

			indTab[i + j * ni + k * (nj * ni)].in = true;
			
		
			d = d->next;

		}
		v = v->next;
	}


	for (i = 0; i < nSize; i++)
	{
		 if (indTab[i].in)  in++;
		 if (indTab[i].out) out++;

		 if (indTab[i].in && indTab[i].out)
			 between++;
	}

	delete [] indTab;

}
/////////////////////////////////////////////////////////////////////////////
