// parallerDoc.h : interface of the CParallerDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARALLERDOC_H__FF44A466_0927_4E10_9C86_B19ACF03EDBB__INCLUDED_)
#define AFX_PARALLERDOC_H__FF44A466_0927_4E10_9C86_B19ACF03EDBB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "console.h"

typedef struct Loop
{
	int start;
	int bound;
	int step;
		

} Loop;

typedef struct Index
{
	int i, j, k;
	int dep;

	bool in;
	bool out;

} Index;

typedef struct Dependence
{
	Index ind0;
	Index ind1;

	GLUquadricObj *sphere;

	Dependence *next;
	
} Dependence;

typedef struct Variable
{
	char *name;

	int  nDep;

	Dependence *pDepRoot;
	Dependence *pDepTemp;
	Dependence *pDepLast;


	Variable *next;

} Variable;

const int READ_WRITE = 0;
const int WRITE_READ = 1;
const int WRITE_WRITE = 2;

class CParallerDoc : public CDocument
{
protected: // create from serialization only
	CParallerDoc();
	DECLARE_DYNCREATE(CParallerDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CParallerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation

	Variable *pVarRoot;
	Variable *pVarTemp;
	Variable *pVarLast;

	int mini;
	int minj;
	int mink;
	int maxi;
	int maxj;
	int maxk;


	CConsole con;
	
	int dimension;
	int realdimension;

    void FindChar(int s);
    int FindString(char *str);
	FILE *file;
	int LoadData(char *filename);
	Loop loop[3];
	Dependence *add_dep(Index ind0, Index ind1);
	Variable   *add_var(char *name);
	void FindIOBVectors();
	int Compare(Index *ind0, Index *ind1);
	bool CompareI(Index *ind0, Index *ind1);
	

	bool FindMinMax();

	void RemoveVariables();

public:
	virtual ~CParallerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CParallerDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PARALLERDOC_H__FF44A466_0927_4E10_9C86_B19ACF03EDBB__INCLUDED_)
