// parallerView.cpp : implementation of the CParallerView class
//

#include "stdafx.h"
#include "paraller.h"

#include "parallerDoc.h"
#include "parallerView.h"
#include <iostream>
#include "shared.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

double globalAspect;
int globalCx;
int globalCy;

CParallerDoc *gpDoc;
extern int runparser(void);
/////////////////////////////////////////////////////////////////////////////
// CParallerView

IMPLEMENT_DYNCREATE(CParallerView, CView)

BEGIN_MESSAGE_MAP(CParallerView, CView)
	//{{AFX_MSG_MAP(CParallerView)
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_TIMER()
	ON_COMMAND(IDC_BUTTON_ZAPISZ, OnButtonZapisz)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParallerView construction/destruction

CParallerView::CParallerView()
{

	m_hRC = 0;

	m_AngleX = 35.f;
	m_AngleY = 20.f;

	m_AngleView = 45.f;


	m_fRangeX = 5;
	m_fRangeY = 5;
	m_fRangeZ = 5;

	m_zTrans = -1.5f*m_fRangeX;
	m_xTrans = m_yTrans = 0.f;

	m_dx = m_dy = 0.f;

	m_bCaptured = false;
	m_bRightButton = false;
	m_bQuad = true;

	m_LightParam[0] = 0;	// X position
	m_LightParam[1] = 0;	// Y position
	m_LightParam[2] = 00;	// Z position
	m_LightParam[3] = 15;	// Ambient light
	m_LightParam[4] = 70;	// Diffuse light
	m_LightParam[5] = 100;	// Specular light
	m_LightParam[6] = 100;	// Ambient material
	m_LightParam[7] = 100;	// Diffuse material
	m_LightParam[8] = 40;	// Specular material
	m_LightParam[9] = 70;	// Shininess material
	m_LightParam[10] = 0;	// Emission material


	dimension = 3;
	DataChange = 0;
    
	sphere = gluNewQuadric();


}

CParallerView::~CParallerView()
{
	KillFont();
//	if (sphere)
//	delete sphere;
}

BOOL CParallerView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CParallerView drawing

void CParallerView::OnDraw(CDC* pDC)
{
	CParallerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


	
	/////////////////////////////////////////////
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity();

	gluPerspective (m_AngleView, globalAspect, 0.1, 10000.);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	SetLight();

	if (dimension == 3)
	{
		glTranslatef(m_xTrans,m_yTrans,m_zTrans);	// to shift
		glRotatef (m_AngleX, 1.0f, 0.0f, 0.0f );	// and to rotate
		glRotatef (m_AngleY, 0.0f, 1.0f, 0.0f );
	}

	//if (DataLoaded)
	DrawScene();

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();

    glOrtho(0, 640, 0, 480, -1, 1);
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
	glColor3ub(255,255,255);
	
	glRasterPos2d(10,10);
	glPrint("Output");
	glRasterPos2d(10,20);
	glPrint("Anti");
	glRasterPos2d(10,30);
	glPrint("Flow");

	glRasterPos2d(570,465);
	glPrint("Out");
	glRasterPos2d(570,455);
	glPrint("In");
	glRasterPos2d(570,445);
	glPrint("InOut");

	glRasterPos2d(610,465);
	glPrint("%d", out);
	glRasterPos2d(610,455);
	glPrint("%d", in);
	glRasterPos2d(610,445);
	glPrint("%d", between);

	glBegin(GL_LINE_STRIP);


	glVertex2d(5,5);
	glVertex2d(100,5);
	glVertex2d(100,40);
	glVertex2d(5,40);
	glVertex2d(5,5);

	glEnd();

	glBegin(GL_LINE_STRIP);

	glVertex2d(565,475);
	glVertex2d(635,475);
	glVertex2d(635,440);
	glVertex2d(565,440);
	glVertex2d(565,475);

	glEnd();

	glColor3ub(0, 255, 255);
	glBegin(GL_LINES);
	glVertex2d(60,12);
	glVertex2d(90,12);
	glEnd();

	glColor3ub(255, 255, 0);
	glBegin(GL_LINES);
	glVertex2d(60,22);
	glVertex2d(90,22);
	glEnd();

	glColor3ub(255, 255, 255);
	glBegin(GL_LINES);
	glVertex2d(60,32);
	glVertex2d(90,32);
	glEnd();

    glMatrixMode(GL_PROJECTION);
    glPopMatrix();   
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();



	SwapBuffers(m_hdc);

}
void CParallerView::LimitAngles()
{
	while (m_AngleX < -360.f)
		m_AngleX += 360.f;
	while (m_AngleX > 360.f)
		m_AngleX -= 360.f;
	while (m_AngleY < -360.f)
		m_AngleY += 360.f;
	while (m_AngleY > 360.f)
		m_AngleY -= 360.f;
}
void CParallerView::SetLight()
{

	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);


	float fPos[] =
	{
		(m_LightParam[0]-50)*m_fRangeX/100,
		(m_LightParam[1]-50)*m_fRangeY/100,
		(m_LightParam[2]-50)*m_fRangeZ/100,
		1.f
	};
	glLightfv(GL_LIGHT0, GL_POSITION, fPos);

	float f = m_LightParam[3]/100.f;
	float fAmbient[4] = { f, f, f, 0.f };
	glLightfv(GL_LIGHT0, GL_AMBIENT, fAmbient);

	f = m_LightParam[4]/100.f;	
	float fDiffuse[4] = { f, f, f, 0.f };
	glLightfv(GL_LIGHT0, GL_DIFFUSE, fDiffuse);

	f = m_LightParam[5]/100.f;
	float fSpecular[4] = { f, f, f, 0.f };
	glLightfv(GL_LIGHT0, GL_SPECULAR, fSpecular);
	
}

void CParallerView::DrawScene()
{

//	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	CParallerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


	if (DataChange)
	{
		pDoc->RemoveVariables();

		CString filename;

		filename = path;
		filename += "\\";
		filename += "loop.out";

		pDoc->LoadData((char *) filename.operator LPCTSTR());

		DataChange = 0;
		
	}

/*	lx = pDoc->loop[0].start;
	rx = pDoc->loop[0].bound;
	ly = pDoc->loop[1].start;
	ry = pDoc->loop[1].bound;
	lz = pDoc->loop[2].start;
	rz = pDoc->loop[2].bound;*/
	lx = pDoc->mini;
	rx = pDoc->maxi;
	ly = pDoc->minj;
	ry = pDoc->maxj;
	lz = pDoc->mink;
	rz = pDoc->maxk;

	if (lx > 0) lx = 0;
	if (ly > 0) ly = 0;
	if (lz > 0) lz = 0;

	if (rx < 0) rx = 0;
	if (ry < 0) ry = 0;
	if (rz < 0) rz = 0;


	glTranslatef( -(rx + lx) / 2.0, -(ry + ly) / 2.0 , -(rz + lz) / 2.0);

	if (ViewAxis)
		DrawAxis();



	DrawVectors();
	


}

/////////////////////////////////////////////////////////////////////////////
// CParallerView diagnostics

#ifdef _DEBUG
void CParallerView::AssertValid() const
{
	CView::AssertValid();
}

void CParallerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CParallerDoc* CParallerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CParallerDoc)));
	return (CParallerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CParallerView message handlers

BOOL CParallerView::OnEraseBkgnd(CDC* pDC) 
{
	
	return true;
}

int CParallerView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	PIXELFORMATDESCRIPTOR pfd =	// Structure used to describe the format
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,			// Version
		PFD_DRAW_TO_WINDOW |	// Supports GDI
		PFD_SUPPORT_OPENGL |	// Supports OpenGL
		PFD_DOUBLEBUFFER,	// Use double buffering (more efficient drawing)
		PFD_TYPE_RGBA,		// No pallettes
		24, 			// Number of color planes
		 			// in each color buffer
		24,	0,		// for Red-component
		24,	0,		// for Green-component
		24,	0,		// for Blue-component
		24,	0,		// for Alpha-component
		0,			// Number of planes
					// of Accumulation buffer
		0,			// for Red-component
		0,			// for Green-component
		0,			// for Blue-component
		0,			// for Alpha-component
		32, 			// Depth of Z-buffer
		0,			// Depth of Stencil-buffer
		0,			// Depth of Auxiliary-buffer
		0,			// Now is ignored
		0,			// Number of planes
		0,			// Now is ignored
		0,			// Color of transparent mask
		0			// Now is ignored
	};

	m_hdc = ::GetDC(GetSafeHwnd());

	int iD = ChoosePixelFormat(m_hdc, &pfd);
	if ( !iD )
	{
		MessageBox("ChoosePixelFormat::Error");
		return -1;
	}

	if ( !SetPixelFormat (m_hdc, iD, &pfd) )
	{
		MessageBox("SetPixelFormat::Error");
		return -1;
	}

	if ( !(m_hRC = wglCreateContext (m_hdc)))
	{
		MessageBox("wglCreateContext::Error");
		return -1;
	}

	if ( !wglMakeCurrent (m_hdc, m_hRC))
	{
		MessageBox("wglMakeCurrent::Error");
		return -1;
	}

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_COLOR_MATERIAL);

	glShadeModel(GL_SMOOTH);				
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);	
	glClearDepth(1.0f);						
//	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);		
	glEnable(GL_BLEND);							
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

    BuildFont();
    DrawScene();
	
	return 0;
}

void CParallerView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	KillTimer(1);

	m_dx = 0.f;
	m_dy = 0.f;

	SetCapture();

	m_bCaptured = true;
	m_pt = point;
	
}

void CParallerView::OnSize(UINT nType, int cx, int cy) 
{
	
	CView::OnSize(nType, cx, cy);
	double dAspect = cx<=cy ? double(cy)/cx : double(cx)/cy;

	globalAspect = dAspect;
	globalCx = cx;
	globalCy = cy;
	glViewport(0, 0, cx, cy);
/*	
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity();

	if (dimension < 3)
	{
  	  glOrtho(lx - 1, rx + 1, ly - 1, ry + 1, -1.0f,1.0f);
	}
	else
	{
	  gluPerspective (m_AngleView, dAspect, 0.1, 10000.);
	}
   glMatrixMode(GL_MODELVIEW);				
   glLoadIdentity();	*/

}

void CParallerView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_bCaptured)
	{
		m_dy = float(point.y - m_pt.y)/10.f;
		m_dx = float(point.x - m_pt.x)/10.f;

		if (nFlags & MK_CONTROL)
		{
			m_xTrans += m_dx;
			m_yTrans -= m_dy;
		}
		else
		{
			if (m_bRightButton)
				m_zTrans += (m_dx + m_dy)/2.f;
			else
			{
				LimitAngles();
				double a = fabs(m_AngleX);
				if (90. < a && a < 270.)
					m_dx = -m_dx;
				m_AngleX += m_dy;
				m_AngleY += m_dx;
			}
		}

		m_pt = point;
		Invalidate(FALSE);
	}
}

void CParallerView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_bCaptured)
	{
		if (fabs(m_dx) > 0.5f || fabs(m_dy) > 0.5f)
			SetTimer(1,33,0);
		else
			KillTimer(1);

		m_bCaptured = false;
		ReleaseCapture();
	}
	
}

void CParallerView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_bRightButton = true;

	OnLButtonDown(nFlags, point);
	
}

void CParallerView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_bRightButton = m_bCaptured = false;
	ReleaseCapture();
	
}

void CParallerView::OnTimer(UINT nIDEvent) 
{
	LimitAngles();
	m_AngleX += m_dy;
	m_AngleY += m_dx;
	Invalidate(FALSE);
	
}
void CParallerView::DrawAxis()
{
	CParallerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


	glLineWidth(2.1f);

	glBegin(GL_LINES);

	if (ShowRealDimension)
	{
		switch( pDoc->realdimension )
		{
			case 1:
					ly = lz = ry = rz = 0;
					break;
			case 2:
				    lz = rz = 0;

		}
	}

	glColor3f(1,1,1);
	glVertex3d(lx,0,0);
	glVertex3d(rx,0,0);
	glVertex3d(0,ly,0);
	glVertex3d(0,ry,0);
	glVertex3d(0,0,lz);
	glVertex3d(0,0,rz);

	float i;
	float step = 1;

	for (i = (lx+step); i < rx; i += step)
	{
		glVertex3d(i, 0, -0.1);
		glVertex3d(i, 0,  0.1);
	}

	for (i = (ly+step); i < ry; i += step)
	{

		glVertex3d(0, i, -0.1);
		glVertex3d(0, i, 0.1);
	}
	for (i = (lz+step); i < rz; i += step)
	{

		glVertex3d(-0.1, 0, i);
		glVertex3d(0.1, 0,  i);
	}
	glEnd();

	glColor3d(0, 1, 0.1);
	if (lx != rx)
	{
		glRasterPos3d(rx, 0, 0);
		glPrint("i");
	}
	if (ly != ry)
	{
		glRasterPos3d(0, ry, 0);
		if (pDoc->realdimension == 2)
		  glPrint("j");
		else
		  glPrint("st");
	}

	if (lz  != rz)
	{
		glRasterPos3d(0, 0, rz);
		if (pDoc->realdimension == 3)
		  glPrint("k");
		else
		  glPrint("st");

	}

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glColor3ub(255,255,0);
	gluSphere(sphere, 0.08, 10, 10 );
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);


}

const int DEP_FLOW = 0;
const int DEP_ANTI = 1;
const int DEP_OUTPUT = 2;

GLvoid CParallerView::DrawArc(float x0, float y0, float z0, float x1, float y1, float z1, int r, int g, int b, int dep)
{

	int step;

	float px, py;


	float dx = x1 - x0;
	float dy = y1 - y0;
	float dz = z1 - z0;

	float d = sqrt(dx * dx + dy * dy + dz * dz);

//	step = d / 20.0;

	int r0;
	int g0;
	int b0;

	if (dep == DEP_FLOW)
	{
		r0 = 255;
		g0 = 255;
		b0 = 255;

	}
	if (dep == DEP_ANTI)
	{
		r0 = 255;
		g0 = 255;
		b0 = 0;

	}
	if (dep == DEP_OUTPUT)
	{
		r0 = 0;
		g0 = 255;
		b0 = 255;

	}

	step = 20;

	glPushMatrix();

	if (d != 0.0)
	{
	
		float rx = d / 2.0;
		float ry = 1/3.0 * rx;

		float stepx = dx / (float) step;
		float stepy = dy / (float) step;
		float stepz = dz / (float) step;

		float sx = x0;
		float sy = y0;
		float sz = z0;


		float angle = (180.0 / (float) step) * (3.1414/180.0);


		glBegin(GL_LINE_STRIP);

 
		for (int i = 0; i <= step; i++)
		{
			py = ry * sin(i * angle);

			if (i == 17)
				glColor3ub(r0, g0, b0);

			glVertex3d(sx, sy + py, sz);

			sx += stepx;
			sy += stepy;
			sz += stepz;
			
		}
		glEnd();



		float st = (float) step - 0.5;

		//angle = (180.0 / st) * (3.1414/180.0);

/*		float x1 = x0 + stepx * st;
		float y1 = y0 + stepy * st + ry * sin(st * angle);
		float z1 = z0 + stepz * st;*/
		//loat x1 = x0 + stepx * st;
		//float y1 = y0 + stepy * st + ry * sin(st * angle);
		//float z1 = z0 + stepz * st;

/*		float x2 = sx - stepx;
		float y2 = sy - stepy;
		float z2 = sz - stepz;

		glTranslatef(x1, y1 - ry * sin(step * angle), z1); 
		glColor3ub(r0, g0, b0);
		//glRotatef(90, 1,0,0);

		//float cosa = acos(x1 * x2 + y1 * y2 + z1 * z2) * 180.0/3.1415;
		//glRotatef(90, 0,1,0);
		//gluCylinder(sphere, 0.03, 0.0, 0.1,10,10);
		gluSphere(sphere, 0.02, 10, 10 );*/


	} else
	{
		float rx = 0.15;
		float ry = 0.1;


		float angle = (360.0 / (float) step) * (3.1414/180.0);

		glTranslatef(x0 - rx, y0, z0);

		glBegin(GL_LINE_STRIP);

 
		for (int i = 0; i <= step; i++)
		{
			if (i == 17)
				glColor3ub(r0, g0, b0);

			px = rx * cos(i * angle);
			py = ry * sin(i * angle);

			glVertex3d(px, py, 0);
			
		}

		glEnd();



	}


	glPopMatrix();


}

GLvoid CParallerView::DrawVectors()
{
	CParallerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	Variable *v;
	Dependence *d;
	
	v = pDoc->pVarRoot;

	static struct colors
	{
		int r;
		int g;
		int b;

	} colors[10] = {255, 10,40,
		            0,120,30,
					22,34,55,
					100,255,0,
					255,40,88,
					111,111,22,
					55,33,11,
					1,1,22,
					102,205,11,
					10,222,45};

	int r,g,b;

	
/*	lx = pDoc->loop[0].start;
	rx = pDoc->loop[0].bound;
	ly = pDoc->loop[1].start;
	ry = pDoc->loop[1].bound;
	lz = pDoc->loop[2].start;
	rz = pDoc->loop[2].bound;*/
	lx = pDoc->mini;
	rx = pDoc->maxi;
	ly = pDoc->minj;
	ry = pDoc->maxj;
	lz = pDoc->mink;
	rz = pDoc->maxk;


	int i0, j0, k0;
	int i1, j1, k1;

	switch (pDoc->realdimension)
	{
		case 1:
				glTranslatef(0.f, 0.3f, 0.3f); 
				break;
		case 2:
				glTranslatef(0.3f, 0.3f, 0.3f); 
				break;
		case 3:
				glTranslatef(0.3f, 0.3f, 0.3f); 
				break;
	}

	if (ShowRealDimension)
	switch(pDoc->realdimension)
	{
		case 1:
			    ly = ry = 0;
				lz = rz = 0;
				break;
		case 2:
			    lz = rz = 0;
				break;

	}

	int i, j, k;

	for (i = lx; i <= rx; i++)
		for (j = ly; j <= ry; j++)
			for (k = lz; k <= rz; k++)
			{

				glEnable(GL_LIGHTING);
				glEnable(GL_LIGHT0);

				glPushMatrix();
				glColor3ub(150, 150, 150);		
				
				glTranslatef(i, j, k);
				
				gluSphere(sphere, 0.05, 10, 10 );
				//gluCylinder(sphere, 0.05,0.0, 0.1,10,10);
				glPopMatrix();

				glDisable(GL_LIGHTING);
				glDisable(GL_LIGHT0);
				glColor3ub(255 ,173,91);

				if (ShowPositions)
				{
					glRasterPos3d(i + 0.05, j + 0.05, k + 0.05);
					switch (pDoc->realdimension)
					{
						case 1:
								if (ShowRealPositions)
									glPrint("[%d]", i);
								else
									glPrint("[%d,%d]", i, j);
								
								break;
						case 2:
						
								if (ShowRealPositions)
									glPrint("[%d,%d]", i, j);
								else
									glPrint("[%d,%d,%d]", i, j, k);

								break; 
						case 3:
								
								glPrint("[%d,%d,%d]", i, j, k);

								break; 
					}
				}
			}

	i = 0;
	while (v)
	{
		d = v->pDepRoot;

		r = colors[i].r;
		g = colors[i].g;
		b = colors[i].b;
		i++;
		if (i > 9) i = 0;

		while (d)
		{
			glColor3ub(r,g,b);

			i0 = d->ind0.i;
			j0 = d->ind0.j;
			k0 = d->ind0.k;

			i1 = d->ind1.i;
			j1 = d->ind1.j;
			k1 = d->ind1.k;

			if (ShowRealDimension)
			{
				switch (pDoc->realdimension)
				{
					case 1:
						    j0 = k0 = 0;
							j1 = k1 = 0;
							break;
					case 2:
						    k0 = k1 = 0;
							break;


				}
			}

			if (!ShowArcs)
			{
				glBegin(GL_LINES);
				glVertex3d(i0, j0, k0);
				glVertex3d(i1, j1, k1);
				glEnd();
			}
			else
			{
				if (pDoc->CompareI(&d->ind0, &d->ind1))

					DrawArc(i0, j0, k0, i1, j1, k1, r, g, b, DEP_FLOW);
				else
					DrawArc(i0, j0, k0, i1, j1, k1, r, g, b, DEP_ANTI);
			}



			d = d->next;

		}

		v = v->next;

	}
}
BOOL CParallerView::RenderToBmp(LPTSTR szFile)
{
	// Opening the file 
	CFile file; 
	if (!file.Open(szFile,CFile::modeWrite | CFile::modeCreate)) 
	{

		AfxMessageBox("Error creating file");
		return FALSE; 
	}

	// Get client geometry 
	CRect rect; 
	GetClientRect(&rect); 
	CSize size(rect.Width(),rect.Height()); 

	// Getting device context 
	CDC *pDC=GetDC(); 

	// changing size.cx 
	size.cx=(size.cx/4)*4; 
	// Alloc pixel bytes 
	int NbBytes = 3 * size.cx * size.cy; 
	unsigned char *pPixelData = new unsigned char[NbBytes]; 

	
	// Make GL Context current 
	VERIFY(wglMakeCurrent(pDC->m_hDC,m_hRC)); 
	// Copy from OpenGL 
	glReadPixels(0,0,size.cx,size.cy,GL_RGB,GL_UNSIGNED_BYTE,pPixelData);

	
	unsigned char id[2];
	unsigned int  filesize;
	unsigned int  reserved;
	unsigned int  dataoffset;
	unsigned int  headersize;
	unsigned int  width;
	unsigned int  height;
	short    int  planes;
	short    int  bpp;
	short    int  compression;
	unsigned int  datasize;
	unsigned int  hresolution;
	unsigned int  vresolution;
	unsigned int  colors;
	unsigned int  importantcolors;


	int bmpsize = 52;

	
	id[0]			= 'B';
	id[1]			= 'M';
	filesize		= bmpsize + size.cx * size.cy * 3;
	dataoffset		= bmpsize;
	headersize		= 0x26;
	width			= size.cx;
	height			= size.cy;
	planes			= 0;
	bpp				= 24;
	compression		= 0;
	datasize		= 0;
	hresolution		= 0;
	vresolution		= 0;
	colors			= 0;
	importantcolors = 0;

	file.Write(&id, 2);
	file.Write(&filesize, 4);
	file.Write(&reserved, 4);
	file.Write(&dataoffset, 4);
	file.Write(&headersize, 4);
	file.Write(&width, 4);
	file.Write(&height, 4);
	file.Write(&planes, 2);
	file.Write(&bpp, 2);
	file.Write(&compression, 2);
	file.Write(&datasize, 4);
	file.Write(&hresolution, 4);
	file.Write(&vresolution, 4);
	file.Write(&colors, 4);
	file.Write(&importantcolors, 4);

    for (int i = 0; i < size.cx * size.cy; i++)
	{
		  unsigned char temp;

		  int adr = i * 3;

		  temp = pPixelData[adr];
		  pPixelData[adr] = pPixelData[adr + 2];
		  pPixelData[adr + 2] = temp;

	}

	file.Write(pPixelData, size.cx * size.cy * 3);

	file.Close();

	delete [] pPixelData; 

	return TRUE; 
}

GLvoid CParallerView::BuildFont(GLvoid)					// Build Our Bitmap Font
{
	HFONT	font;										// Windows Font ID

	base = glGenLists(96);								// Storage For 96 Characters

	font = CreateFont(	-10,							// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						"Terminal");						// Font Name

	SelectObject(m_hdc, font);							// Selects The Font We Want

	wglUseFontBitmaps(m_hdc, 32, 96, base);				// Builds 96 Characters Starting At Character 32
}

GLvoid CParallerView::KillFont(GLvoid)					// Delete The Font
{
	glDeleteLists(base, 96);							// Delete All 96 Characters
}

GLvoid CParallerView::glPrint(const char *fmt, ...)		// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base - 32);								// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}


void CParallerView::OnButtonZapisz() 
{
	
	CFileDialog dlg(FALSE, "*.bmp", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		            "bmp (*.bmp)|*.bmp|All Files (*.*)|*.*||", NULL);

	int response = dlg.DoModal();

	if (response == IDOK)
	{

		CString filename = dlg.GetFileName();

		char file[256];

		strcpy(file, filename.operator LPCTSTR());

		RenderToBmp(file);
	}
	
}
