// parallerView.h : interface of the CParallerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARALLERVIEW_H__A1AAAE3E_0B16_4A79_8079_5260B3E1E2CC__INCLUDED_)
#define AFX_PARALLERVIEW_H__A1AAAE3E_0B16_4A79_8079_5260B3E1E2CC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CParallerView : public CView
{
protected: // create from serialization only
	CParallerView();
	DECLARE_DYNCREATE(CParallerView)

// Attributes
public:
	CParallerDoc* GetDocument();

// Operations
public:
	long	m_BkClr;	// Background color
	HGLRC	m_hRC;		// Rendering context OpenGL
	HDC	m_hdc;			// Windows device context
	GLfloat	m_AngleX;	// Rotation angle (around X-axis)
	GLfloat m_AngleY;	// Rotation angle (around Y-axis)
	GLfloat	m_AngleView;// Perspective angle
	GLfloat	m_fRangeX;	// Graphics dimension (along X-axis)
	GLfloat m_fRangeY;	// Graphics dimension (along Y-axis)
	GLfloat m_fRangeZ;	// Graphics dimension (along Z-axis)
	GLfloat	m_dx;		// Displacement quantum (along X-axis)
	GLfloat m_dy;		// Displacement quantum (along Y-axis)
	GLfloat	m_xTrans;	// Displacement (along X-axis)
	GLfloat m_yTrans;	// Displacement (along Y-axis)
	GLfloat m_zTrans;	// Displacement (along Z-axis)
	GLenum	m_FillMode;	// Polygon filling mode
	bool	m_bCaptured;	// Mouse capture flag
	bool	m_bRightButton;	// Right mouse button flag
	bool	m_bQuad;	// Flag of using GL_QUAD (instead of GL_QUAD_STRIP)
	CPoint	m_pt;		// Current mouse position
	UINT	m_xSize;	// Current client window sixe (along X-axis)
	UINT	m_zSize;	// Current client window sixe (along -axis)
	int	m_LightParam[11];	// Graphics dimension (along X-axis)


	int lx;
	int rx;
	int ly;
	int ry;
	int lz;
	int rz;

	void DrawScene();	// Prepare and store the image
	void SetLight();				// Set the lighting
	void LimitAngles();				// Limit rotation angles
	void DrawAxis();
	void DrawVectors();
    void DrawArc(float x0, float y0, float z0, float x1, float y1, float z1, int r, int g, int b, int type);
    BOOL RenderToBmp(LPTSTR szFile);


    GLUquadricObj *sphere;
	int dimension;

	GLuint	base;			// Base Display List For The Font Set
	

	GLvoid BuildFont(GLvoid);
	GLvoid KillFont(GLvoid);				
	GLvoid glPrint(const char *fmt, ...);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CParallerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CParallerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CParallerView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonZapisz();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in parallerView.cpp
inline CParallerDoc* CParallerView::GetDocument()
   { return (CParallerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PARALLERVIEW_H__A1AAAE3E_0B16_4A79_8079_5260B3E1E2CC__INCLUDED_)
